package heapStacking;

import heapStacking.problems.HSP2;

import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Properties;
import jmetal.core.*;
import jmetal.operators.crossover.*;
import jmetal.operators.mutation.*;
import jmetal.operators.selection.*; 
import jmetal.metaheuristics.nsgaII.ssNSGAII;
import jmetal.util.JMException;

public class HeapStackingMain {
	public static void main(String [] args) throws JMException, ClassNotFoundException, FileNotFoundException, IOException {
		if (args.length != 1) {
			System.out.println("Please supply the base directory as the first argument");
			return;
		}

		String baseDirectory = args[0] + "\\";
		String output = "";
		
		for (int i = 0; i <= 10; i++) {
			HeapStacker stacker = new HeapStacker(baseDirectory + "quality_input\\verlauf" + Integer.toString(i) + ".txt", 300, 50, 20, 20);
			double[] positions = new double[20];
			
			for (int j = 0; j < 20; j++) {
				positions[j] = (double)(j % 2);
			}
			
			double[] fitness = stacker.evaluatePositions(positions);
			output += Double.toString(fitness[0]) + " " + Double.toString(fitness[1]) + "\n";
		}

		try{
			FileWriter fstream = new FileWriter(baseDirectory + "results.csv");
			BufferedWriter out = new BufferedWriter(fstream);
			out.write(output);
			out.close();
		}catch (Exception e){
			System.err.println("Error: " + e.getMessage());
		}
		
		/*
		Properties properties = new Properties();
		properties.load(new FileInputStream(baseDirectory + "\\config.ini"));
			
		Problem problem = new HSP2("Out", baseDirectory, "quality_input\\verlauf0.txt");
		Algorithm algorithm = new ssNSGAII(problem);
		
		algorithm.setInputParameter("populationSize", Integer.parseInt(properties.getProperty("population_size")));
		algorithm.setInputParameter("maxEvaluations", Integer.parseInt(properties.getProperty("max_evaluations")));

		HashMap<String, Double> parameters = new HashMap<String, Double>();
		parameters.put("probability", 0.9);
		parameters.put("distributionIndex", 20.0);
		Operator crossover = CrossoverFactory.getCrossoverOperator("SBXCrossover", parameters); 
		algorithm.addOperator("crossover", crossover);
	
		parameters = new HashMap<String, Double>();				 
		parameters.put("probability", 1.0 / problem.getNumberOfVariables());
		parameters.put("distributionIndex", 20.0);
		Operator mutation = MutationFactory.getMutationOperator("PolynomialMutation", parameters);   
		algorithm.addOperator("mutation", mutation); 

		parameters = new HashMap<String, Double>();
		Operator selection = SelectionFactory.getSelectionOperator("BinaryTournament", parameters);   
		algorithm.addOperator("selection", selection);						 
		
		SolutionSet population = algorithm.execute();
		
		population.printObjectivesToFile(baseDirectory + "FUN");
		System.out.println("Objective values have been written");
		
		population.printVariablesToFile(baseDirectory + "VAR");
		System.out.println("Variable values have been written");
*/
	}
}
