package heapStacking.problems;

import java.io.FileNotFoundException;
import java.io.IOException;
import jmetal.core.*;
import jmetal.encodings.variable.ArrayReal;

@SuppressWarnings("serial")
public class HSP1 extends HSPSpeedsBase {
	public HSP1(String problemName, String baseDirectory, String qualityFile) throws ClassNotFoundException, FileNotFoundException, IOException {
		super(problemName, baseDirectory, qualityFile);
		
	    numberOfObjectives_ = 2;
	    numberOfConstraints_= 0;
	}
	
	// Speed representation
	// Repairing for representation
		
	public void evaluate(Solution solution) {
		ArrayReal variable = ((ArrayReal)solution.getDecisionVariables()[0]);
		double[] strategy = new double[variable.size_];
		
		for (int i = 0; i < variable.size_; i++) {
			strategy[i] = variable.array_[i];
		}
		
		double[] fitness = stacker.evaluateSpeeds(strategy);

		solution.setObjective(0, fitness[0]);
		solution.setObjective(1, fitness[1]);
		
		Log(fitness[0], fitness[1]);
	}
}