package heapStacking.problems;

import java.io.FileNotFoundException;
import java.io.IOException;
import jmetal.core.Solution;
import jmetal.core.Variable;
import jmetal.encodings.variable.ArrayReal;
import jmetal.util.JMException;

@SuppressWarnings("serial")
public class HSP4 extends HSPPositionsBase {
	public HSP4(String problemName, String baseDirectory, String qualityFile) throws FileNotFoundException, ClassNotFoundException, IOException {
		super(problemName, baseDirectory, qualityFile);
		
	    numberOfObjectives_ = 2;
	    numberOfConstraints_= 0;
	}

	// Position representation
	// Repairing individuals (simple method)

	@Override
	public void evaluate(Solution solution) throws JMException {
		Variable[] variables = solution.getDecisionVariables();
		double[] strategy = new double[numberOfVariables_];

		for (int i = 0; i < numberOfVariables_; i++) {
			strategy[i] = ((ArrayReal)variables[0]).array_[i];

			if (i > 0) {
				if (strategy[i] >= strategy[i - 1]) {
					if (strategy[i] - strategy[i - 1] > maxDistance) {
						strategy[i] = strategy[i - 1] + maxDistance;
						((ArrayReal)variables[0]).array_[i] = strategy[i];
					}
				} else {
					if (strategy[i - 1] - strategy[i] > maxDistance) {
						strategy[i] = strategy[i - 1] - maxDistance;
						((ArrayReal)variables[0]).array_[i] = strategy[i];
					}
				}
			}
		}
		
		solution.setDecisionVariables(variables);
		
		double[] fitness = stacker.evaluatePositions(strategy);

		solution.setObjective(0, fitness[0]);
		solution.setObjective(1, fitness[1]);

		Log(fitness[0], fitness[1]);
	}
}