package heapStacking.problems;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Properties;

@SuppressWarnings("serial")
public abstract class HSPPositionsBase extends HSPBase {
	protected double maxDistance;
	
	public HSPPositionsBase(String problemName, String baseDirectory, String qualityFile) throws ClassNotFoundException, FileNotFoundException, IOException {
		super(problemName, baseDirectory, qualityFile);
		
		Properties properties = new Properties();
		properties.load(new FileInputStream(baseDirectory + "\\config.ini"));
				
		int maxLayers = Integer.parseInt(properties.getProperty("max_layers"));
		int variableCount = Integer.parseInt(properties.getProperty("variable_count"));
		maxDistance = maxLayers >= variableCount ? 1.0 : ((double)maxLayers / (double)variableCount);

	    for (int var = 0; var < numberOfVariables_; var++){
	      lowerLimit_[var] = 0.0;
	      upperLimit_[var] = 1.0;
	    }
	}
}