package heapStacking.study;

import java.lang.reflect.Constructor;
import jmetal.core.Problem;
import jmetal.util.Configuration;
import jmetal.util.JMException;

public class HeapStackingProblemFactory {
	@SuppressWarnings("rawtypes")
	public Problem getProblem(String name, Object [] params) throws JMException {
		String problemClassName = "heapStacking.problems." + name.split("_")[0];
		
		try {
			Class problemClass = Class.forName(problemClassName);
			Constructor [] constructors = problemClass.getConstructors();
			int i = 0;
			
			while ((i < constructors.length) && (constructors[i].getParameterTypes().length != params.length)) {
				i++;
			}
			
			return (Problem)constructors[i].newInstance(params);			
		} catch(Exception e) {
			Configuration.logger_.severe("Problem class '" + problemClassName + "' does not exist.");
			throw new JMException("Exception in HeapStackingProblemFactory.getProblem()");
		}						
	}		
}
