package heapStacking.study;

import java.util.Properties;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import jmetal.core.Algorithm;
import jmetal.experiments.Experiment;
import jmetal.experiments.Settings;
import jmetal.util.JMException;

public class HeapStackingStudy extends Experiment {
	private static String baseDirectory;
	
	public void algorithmSettings(String problemName, int problemIndex, Algorithm[] algorithm) throws ClassNotFoundException {
		try {
			algorithm[0] = new HeapStackingSettingsSSNSGAII(baseDirectory, problemName).configure();
		} catch (IllegalArgumentException ex) {
			Logger.getLogger(HeapStackingStudy.class.getName()).log(Level.SEVERE, null, ex);
		} catch	(JMException ex) {
			Logger.getLogger(HeapStackingStudy.class.getName()).log(Level.SEVERE, null, ex);
		} catch (FileNotFoundException ex) {
			Logger.getLogger(HeapStackingStudy.class.getName()).log(Level.SEVERE, null, ex);
		} catch (IOException ex) {
			Logger.getLogger(HeapStackingStudy.class.getName()).log(Level.SEVERE, null, ex);
		}
	}

	public static void main(String[] args) throws JMException, IOException {
		String algorithmNumber = "";
		
		if (args.length == 2) {
			baseDirectory = args[0] + "\\";
			algorithmNumber = args[1];
		} else {
			System.err.println("Invalid argument count: Please supply arguments \"base directory\" and \"algorithm number\"!");
			System.exit(-1);
		}
		
		HeapStackingStudy exp = new HeapStackingStudy();
		
		int verlaufCount = 11;
		
		String [] problems = new String[verlaufCount];
		
		for (int i = 0; i < verlaufCount; i++) {
			problems[i] = "HSP" + algorithmNumber + "_verlauf" + Integer.toString(i);
		}
		
		exp.experimentName_ = "HeapStackingStudy";
		exp.algorithmNameList_ = new String[] {"ssNSGAII HSP" + algorithmNumber};
		exp.problemList_ = problems;
		exp.indicatorList_ = new String[] {};
		exp.paretoFrontFile_ = new String[] {};
		exp.experimentBaseDirectory_ = baseDirectory;
		exp.paretoFrontDirectory_ = "";
		exp.algorithmSettings_ = new Settings[exp.algorithmNameList_.length];
		
		Properties properties = new Properties();
		properties.load(new FileInputStream(baseDirectory + "\\config.ini")); 
		
		exp.independentRuns_ = Integer.parseInt(properties.getProperty("independent_runs"));

		exp.runExperiment(problems.length /*number of threads*/);
	}
}